<template>
  <div style="margin: 3rem">
    <header style="margin:10rem 6rem 3rem 6rem">
      <ReturnButton
        :offsetArrow="21"
        :spanTitle="2"
        title="Regresar"
        v-on:clickEvent="modalReturnBtn = true"
        style="margin-bottom:2.5rem"
      ></ReturnButton>
      <el-row :gutter="20">
        <!-- BUSCADOR -->
        <el-col :span="6" :offset="18">
          <app-search-filter v-model="textSearch"></app-search-filter>
        </el-col>
      </el-row>
    </header>

    <!-- COMPONENTE TITULO -->
    <div style="margin:3rem 6rem">
      <app-title
        :Title=" `ALMACEN DE ${(itemSupportMat.originalTitle).toUpperCase()}`"
        bgcolor="background-color: #818181 !important"
      ></app-title>
    </div>

    <section style="margin:0rem 8rem 4rem">
      <el-row style="margin:0 0 1rem 3rem">
        <el-col :span="6">
          <span>
            Total de Capítulos:
            <br />
          </span>
        </el-col>
        <el-col :span="12">
          <span>
            {{ seasonFilterByTemp.chapters }}
            <br />
          </span>
        </el-col>
      </el-row>

      <el-row style="margin:0 0 1rem 3rem">
        <el-col :span="6">
          <span class="text-orange">
            Capítulos Copiados:
            <br />
          </span>
        </el-col>
        <el-col :span="12">
          <span class="text-orange">{{ capRegister }}</span>
        </el-col>
      </el-row>

      <!-- TITULO DE LOS RANGOS  -->
      <div
        style="background-color: #fedbcc !important; color: #252525 !important; padding: 8px 20px; margin-top:3rem"
      >
        <h3 class="text-bold">
          <span class="bolt" style="margin-left: 10px">{{ rangesCapsSelected }}</span>
        </h3>
      </div>

      <!-- SELECT QUE FILTRA LA TEMPORADA  -->
      <div style="margin:3rem 4rem">
        <el-row :gutter="20">
          <el-col :span="6" :offset="18">
            <el-select
              @change="changeSeason(temporada)"
              v-model="temporada"
              placeholder="rangos de capítulos"
              style="width: 100%"
            >
              <el-option
                v-for="item in selectItems"
                :key="item.value"
                :label="item.label"
                :value="item.value"
              ></el-option>
            </el-select>
          </el-col>
        </el-row>
      </div>

      <!-- CHECKBOX  -->
      <el-row style="margin:4rem 0 1rem 3rem">
        <el-col :span="16">
          <el-checkbox
            @change="selectTotalCapCheck(checked)"
            style="padding: 10px"
            class="bg-gray bold"
            size="medium"
            v-model="checked"
          >Marcar todos los materiales como recibidos.</el-checkbox>
        </el-col>
      </el-row>
    </section>

    <!-- CARDS  -->
    <el-main style="margin:3rem 8rem">
      <el-row :gutter="40">
        <el-col :span="12" v-for="(item, index) in totalNumbChapter" :key="index">
          <el-collapse class="recept-accordion" style="margin-bottom:3rem">
            <el-collapse-item class="recept-accordion-child">
              <template slot="title">
                <el-row>
                  <el-col :span="20">
                    <div class="recept-accordion-title">
                      <i class="el-icon-caret-right"></i>
                      <div class="box-title">
                        <span class="title-accordion">{{ item.nameCap }}</span>
                        <span
                          class="text-bold text-red"
                          style="font-size:14px; margin-left:2rem"
                        >{{item.stateReplacement}}</span>
                      </div>
                    </div>
                    <el-radio-group
                      class="recept-accordion-status"
                      @change="selectOption"
                      v-model="item.stateStorage"
                    >
                      <el-radio label="Pendiente">Pendiente</el-radio>
                      <el-radio label="Copiado">Copiado</el-radio>
                    </el-radio-group>
                  </el-col>
                  <el-col :span="4" style="text-align: center; margin-top: 20px;">
                    <img
                      src="../../../../assets/images/borrador-rojo.svg"
                      @click="ModalClean(index, item)"
                    />
                  </el-col>
                </el-row>
              </template>

              <div>
                <el-row
                  style="margin: 3rem 0px 25px; background: #E0E0E0; padding: 2px 8px; font-size: 15px;"
                >
                  <el-col :span="12">
                    <h4 class="text-green">COPIA DE BACK UP:</h4>
                  </el-col>
                  <el-col :span="4">
                    <el-radio v-model="item.copyBackUpStorage" label="SÍ">SÍ</el-radio>
                  </el-col>
                  <el-col :span="4">
                    <el-radio v-model="item.copyBackUpStorage" label="NO">NO</el-radio>
                  </el-col>
                </el-row>

                <!-- item.reposicion[item.reposicion.length - 1].arrivalDate -->
                <el-row style="margin-top: 3rem">
                  <el-col :span="12">
                    <h3 class="text-orange" style="margin:0 0 1rem">ALMACENAMIENTO:</h3>
                    <el-row style="margin: 12px 0;" type="flex" align="middle">
                      <el-col :span="12" class="subtitles-chapter-form">Fecha de Copiado:</el-col>
                      <el-col :span="12">
                        <el-date-picker
                          style="width: 100%"
                          v-model="item.dateCopy"
                          type="date"
                          format="dd/MM/yyyy"
                          value-format="timestamp"
                        ></el-date-picker>
                      </el-col>
                    </el-row>
                    <el-row style="margin: 12px 0;" type="flex" align="middle">
                      <el-col :span="12" class="subtitles-chapter-form">Almacenamiento:</el-col>
                      <el-col :span="15">
                        <app-select v-model="item.storage" :filterArray="allstorages"></app-select>
                      </el-col>
                    </el-row>

                    <el-row style="margin: 12px 0;" type="flex" align="middle">
                      <el-col :span="12" class="subtitles-chapter-form">Videoteca:</el-col>
                      <el-col :span="15">
                        <app-select v-model="item.videoteca" :filterArray="videotecaArray"></app-select>
                      </el-col>
                    </el-row>
                  </el-col>
                  <el-col :span="10" :offset="2">
                    <h3 class="text-orange" style="margin:0 0 1rem">SOPORTE:</h3>
                    <div>
                      <el-row v-for="(typeStorage, i) in item.typeStorage" :key="i">
                        <el-col>
                          <el-col class="subtitles-chapter-form">Soporte de Almacén:</el-col>
                          <el-col :span="14" style="margin:0.5rem 0">
                            <app-select
                              v-model="typeStorage.typeStorage"
                              :filterArray="typeStorageArray"
                              size="small"
                            ></app-select>
                          </el-col>
                          <el-col :span="1" style="margin:0.5rem 0.5rem">
                            <span>
                              <i
                                @click="addElement( item.typeStorage, i )"
                                class="el-icon-circle-plus text-orange"
                                style="font-size:25px"
                              ></i>
                            </span>
                          </el-col>
                          <el-col
                            v-if="item.typeStorage.length > 1"
                            :span="1"
                            style="margin:0.5rem 0.5rem"
                          >
                            <span>
                              <i
                                @click="removeElement( item.typeStorage, i )"
                                class="el-icon-remove text-gray"
                                style="font-size:25px; margin-left: 4px"
                              ></i>
                            </span>
                          </el-col>
                        </el-col>
                        <el-col style="margin-bottom: 1rem">
                          <el-col
                            style="margin-top:0.5rem"
                            class="subtitles-chapter-form"
                          >Código de Disco:</el-col>
                          <el-col :span="12">
                            <el-input
                              v-model="typeStorage.codeDisk"
                              size="small"
                              :disabled="isChooseCopyBackup(item.copyBackUpStorage)"
                            ></el-input>
                          </el-col>
                        </el-col>
                      </el-row>
                    </div>
                  </el-col>
                </el-row>

                <el-row>
                  <el-col :offset="20" style="margin-top: 4rem">
                    <el-button
                      @click="eventBtnCopy(item, item.chapter)"
                      size="small"
                      type="primary"
                    >COPIAR</el-button>
                  </el-col>
                </el-row>
              </div>
            </el-collapse-item>
          </el-collapse>
        </el-col>
      </el-row>
    </el-main>

    <section style="margin:5rem 6rem 4rem 6rem">
      <el-row>
        <el-col :span="2" :offset="17">
          <el-button
            size="medium"
            v-on:click="modalCancelButton = true"
            type="primary"
            plain
          >CANCELAR</el-button>
        </el-col>
        <el-col :span="1" :offset="2">
          <el-button size="medium" @click="enterNewOrder" type="primary">REGISTRAR</el-button>
        </el-col>
      </el-row>
    </section>

    <!-- Modal botón copiar-->
    <app-modal
      :show-dialog.sync="modalCopy"
      v-if="modalCopy"
      nameClass="dialog-orange"
      :rutImg="require(`../../../../assets/images/suspicious.svg`)"
      sizeImg="80px"
      textBold="¡Un momento!"
      typeBtn1="primary"
      :parrafo="'¿Quieres <strong>'+  copy   + '</strong> la informacion en todos los capítulos? ' "
      classBtn1="border-orange"
      btn1="SI, COPÍAR"
      btn2="CANCELAR"
      @btnEvent="btnCopiar"
      v-on:eventBtn="modalCopy = false"
    ></app-modal>

    <!-- Modal botón ingresar-->
    <!-- :parrafo="'Se guardó la información de los capítulos de <strong>' + itemSupportMat.originalTitle + ' <strong>'" -->

    <AppModalSuccess
      :show-dialog.sync="enterSupportModal"
      v-if="enterSupportModal"
      :parrafo="'Se guardó la información de la recepción de los capítulos'"
      btn1="ACEPTAR"
      @btnEvent="enterSupportModal = false"
      v-on:btnEvent="returnPage"
    ></AppModalSuccess>

    <!-- Modal botón cancelar -->
    <AppModalDanger
      :show-dialog.sync="modalCancelButton"
      v-if="modalCancelButton"
      v-on:btnEvent="returnPage"
      @btnEvent="modalCancelButton = false"
      v-on:eventBtn="modalCancelButton = false"
    ></AppModalDanger>

    <!-- Modal botón de retroceder RETURNBUTTON -->
    <AppModalDanger
      parrafo="Si te vas sin guardar, la información se perderá."
      :show-dialog.sync="modalReturnBtn"
      v-if="modalReturnBtn"
      v-on:btnEvent="returnPage"
      @btnEvent="modalReturnBtn = false"
      v-on:eventBtn="modalReturnBtn = false"
    ></AppModalDanger>

    <!-- Modal del borrardor -->
    <app-modal
      :show-dialog.sync="clean"
      v-if="clean"
      nameClass="dialog-red"
      :rutImg="require(`../../../../assets/images/alerta.svg`)"
      sizeImg="65px"
      textBold="¡Un momento!"
      :parrafo="'¿Seguro de que quieres borrar la informacion ingresada?'"
      classBtn1="border-red"
      typeBtn1="danger"
      btn1="SÍ, BORRAR"
      btn2="CANCELAR"
      @btnEvent="borrarInfo"
      v-on:eventBtn="clean = false"
    ></app-modal>
  </div>
</template>

<script>
  import ReturnButton from '@/components/ReturnButton.vue'
  import Title from '@/components/Title.vue'  
  import SearchFilter from '@/components/searchFilter.vue'
  import { HTTP } from '../../../../main.js' 
  import Select from '@/components/AppSelect.vue'
  import AppModal from '@/components/AppModal.vue'
  import AppModalSuccess from '@/components/AppModalSuccess.vue'
  import AppModalDanger from '@/components/AppModalDanger.vue'
  import { modifyText } from '../../../../utils/modifyText.js'
  // import {isChooseCopyBackup} from '@/utils/util.js'

  export default {
    components: {
      ReturnButton,
      AppModalSuccess,
      AppModalDanger,
     'app-search-filter': SearchFilter, 
     'app-title': Title,
     'app-select': Select,
     'app-modal': AppModal
    },
    data() {
      return {
        clean: false,
        modalReturnBtn: false,
        stateBtnSup: JSON.parse(this.$localStorage.get("stateBtnSup")), 
        itemStorage: {},
        enterSupportModal: false,
        modalCancelButton: false,
        indexStorage: 0,
        textSearch: '',
        idSupportMat: JSON.parse(this.$localStorage.get("idSupportMat")),  
        itemSeleccionado: JSON.parse(this.$localStorage.get("itemSeleccionado")),
        itemSupportMat: [],
        season: [],
        selectItems: [],
        textarea3: '',
        checked: false,
        temporada: '',
        seasonFilterByTemp: {},
        stateStorage: '',
        modalCopy: false,
        copy: 'copiar',
        indexTemp: 0,
        indexItemCap: 0,
        itemCap: {}, 

        // televisa
        allShipping: [],
        methodsArrival: [],
        stateBtnStorageSupport: JSON.parse(this.$localStorage.get("stateBtnStorageSupport")), 
        allstorages: [
          {value: 'Master', label: 'Master'},
          {value: 'Producción Nacional', label: 'Producción Nacional'},
        ],

        videotecaArray: [
          {value: 'Santa Beatriz', label: 'Santa Beatriz'},
          {value: 'Pachacamac', label: 'Pachacamac'},
        ],

        typeStorageArray: [
          {value: 'XD CAM 50 - GB', label: 'XD CAM 50 - GB'},
          {value: 'XD CAM 23 - GB', label: 'XD CAM 23 - GB'},
          {value: 'DISCO OPTICO 1.5 Tb', label: 'DISCO OPTICO 1.5 Tb'},
        ],
        rangesCapsSelected : "",
        newArrChaptersRanges: [],
        rangesCapsDefaulChanges: []
      }
    },
    created () {
      // this.getTablesSupport() 
      this.getSupportMaterials();  
    },
    methods: { 
      getSupportMaterials () {
         this.itemSupportMat = this.itemSeleccionado;
         this.season = this.itemSeleccionado.numChapters;
         this.seasonFilterByTemp = this.itemSeleccionado.numChapters[0]
         
          if (this.stateBtnStorageSupport == 'PENDIENTE') {
            this.enterProperties()
          }
          this.selectFilterSeason();    
      },
      addElement (item, index) {
        let code =  {typeStorage: '', codeDisk: ''}
        item.push(code)
      },
      removeElement (item, index) {
        item.splice(index, 1)

      },
     ModalClean(index, item) {
       this.indexItemCap = index
       this.itemCap = item
       this.clean = true
      },
     enterNewOrder () {
       let revisadoYes = 0
       let revisadoNot = 0 
       let totalCap = 0

      // funcion que contabiliza si todos los capitulos de todas las temporadas han sido llenados
       this.itemSupportMat.numChapters.map((ella, index, arr) => {
        totalCap += Number(ella.chapters)
         ella.infoByChapter.map((el, i, arr) => {
           if(el.dateCopy == '' || el.videoteca == '' || el.storage == '' || el.typeStorage == '') {
             revisadoNot += 1            
           }
           else {
             revisadoYes += 1
             if(el.replacementStorage == true ) {
               el.replacementStorage = false
             }       
           }
         })
       })

       if(revisadoYes === totalCap ) {
          this.itemSupportMat.colorBtnStorageSupport = 'success'
          this.itemSupportMat.stateBtnStorageSupport = 'COMPLETO'
        }
        else if (revisadoNot == totalCap ) {
          this.itemSupportMat.colorBtnStorageSupport = 'info'
          this.itemSupportMat.stateBtnStorageSupport = 'PENDIENTE'
        }

        else {
          this.itemSupportMat.colorBtnStorageSupport = 'danger'
          this.itemSupportMat.stateBtnStorageSupport = 'INCOMPLETO'
        }

        HTTP.patch(`materials/update/${this.itemSupportMat.__id}` , [
          { propName: "stateBtnStorageSupport", value: this.itemSupportMat.stateBtnStorageSupport },
          { propName: "numChapters", value: this.itemSupportMat.numChapters },
          { propName: "colorBtnStorageSupport", value: this.itemSupportMat.colorBtnStorageSupport },
          { propName: "storageMat", value: this.itemSupportMat.numChapters }           
          ])
        .then(res => {
          res.data;
          this.enterSupportModal = true
        })
        .catch(err => console.log(err))
     
     },   
      returnPage () {
        this.$router.push({name: 'almacenTelevisa'})
      },
      enterProperties () {
        this.season.map((el, index, arr) => {
          this.$set(el, 'copiedChapters', 0)
          el.infoByChapter.map((ella, i, arr) => {
            if(ella.dateCopy == undefined) {
              this.$set(ella, 'dateCopy', '') 
              this.$set(ella, 'storage', '' ) 
              this.$set(ella, 'typeStorage', [{ typeStorage: '', codeDisk: '' }] ) 
              this.$set(ella, 'videoteca', '') 
              this.$set(ella, 'stateStorage', 'Pendiente') 
              // this.$set(ella, 'codeDisk', '') 
              this.$set(ella, 'copyBackUpStorage', '') 

            }
          })
        })
      },
      selectFilterSeason () {
        console.log('selectFilterSeason')
        this.selectItems = []
        if ( this.seasonFilterByTemp.infoByChapter.length > 100 ) {
          this.newArrChaptersRanges = []
          let divisionTotalCapAndCapsLimited = (this.seasonFilterByTemp.infoByChapter.length / 100)
          let endLimit = 100
          let startLimit = 0
          for (let i = 0; i < Math.ceil(divisionTotalCapAndCapsLimited); i++) {
            let capsFilter = this.seasonFilterByTemp.infoByChapter.filter( m => {
              return m.chapter <= endLimit && m.chapter > startLimit
            })
            
            let objt = {
              value: i,
              label: 'Capítulos del ' + capsFilter[0].chapter + ' al ' + capsFilter[capsFilter.length -1].chapter
            }

            this.selectItems.push(objt)
            this.newArrChaptersRanges.push(capsFilter)
            endLimit += 100
            startLimit += 100
          }
          this.rangesCapsSelected = this.selectItems[0].label
          
          this.rangesCapsDefaulChanges = this.newArrChaptersRanges[0]
        }
        else {
          let firstCap = !this.seasonFilterByTemp.firstCap ? 1 : this.seasonFilterByTemp.firstCap
          let lastCap = !this.seasonFilterByTemp.lastCap ? this.seasonFilterByTemp.infoByChapter.length : this.seasonFilterByTemp.lastCap
          let objt = {
            value: 0,
            label: `Capítulos del ${firstCap} al ${lastCap}`
          }
          this.selectItems.push(objt)
          this.newArrChaptersRanges.push(this.seasonFilterByTemp.infoByChapter)
          this.rangesCapsSelected = this.selectItems[0].label
          this.rangesCapsDefaulChanges = this.newArrChaptersRanges[0]
        }
        let addTypeStorageMat = this.newArrChaptersRanges[0]
        let addTypeStorageMatTransform = addTypeStorageMat.map((e) => {
          if(!e.typeStorage || e.typeStorage == '') {
            e.typeStorage =  [{typeStorage: '', codeDisk: ''}]
          }
          return e
        })
        this.rangesCapsDefaulChanges = addTypeStorageMat
        // console.log(this.rangesCapsSelected, 'this.rangesCapsSelected')
        // this.season.map((el, i, arr) => {
        //   let objt = {
        //     value: i,
        //     label: el.seasonString
        //   }
        //   this.selectItems.push(objt)
        // })  
      },
      changeSeason (temp) {
        this.rangesCapsDefaulChanges = []
        this.rangesCapsDefaulChanges = this.newArrChaptersRanges[temp]
        this.rangesCapsSelected = this.selectItems[temp].label
        
        // this.seasonFilterByTemp = []
        // this.seasonFilterByTemp = this.season[temp]
        this.indexTemp = temp
      },
      selectTotalCapCheck (checked) {
        if(checked === true) {
          this.seasonFilterByTemp.infoByChapter.map((el, i, arr) => {
            el.stateStorage = 'Copiado'
          })
        }
        else {
          this.seasonFilterByTemp.infoByChapter.map((el, i, arr) => {
            el.stateStorage = 'Pendiente'
          })
        }
      },
      btnCopiar () {
        // for (let i = this.indexStorage; i < this.seasonFilterByTemp.infoByChapter.length; i ++) {   
        //   this.seasonFilterByTemp.infoByChapter[i].dateCopy = this.itemStorage.dateCopy
        //   this.seasonFilterByTemp.infoByChapter[i].stateStorage = this.itemStorage.stateStorage
        //   this.seasonFilterByTemp.infoByChapter[i].videoteca = this.itemStorage.videoteca
        //   this.seasonFilterByTemp.infoByChapter[i].storage = this.itemStorage.storage 
        //   this.seasonFilterByTemp.infoByChapter[i].typeStorage = this.itemStorage.typeStorage 
        //   this.seasonFilterByTemp.infoByChapter[i].codeDisk = this.itemStorage.codeDisk 
        //   this.seasonFilterByTemp.infoByChapter[i].copyBackUpStorage = this.itemStorage.copyBackUpStorage  
        // }
        this.copyRestCaps()
        this.modalCopy = false
        this.selectOption()
      },
      copyRestCaps() {
        let capsReception = this.totalNumbChapter.map((e) => e.chapter)
        let allChapters = this.seasonFilterByTemp.infoByChapter.map((e) => e.chapter)
        allChapters.forEach((e, i) => {
           if(capsReception.includes(e)) {
            if(e >= this.indexStorage) {
              this.seasonFilterByTemp.infoByChapter[i].dateCopy = this.itemStorage.dateCopy
            this.seasonFilterByTemp.infoByChapter[i].stateStorage = this.itemStorage.stateStorage
            this.seasonFilterByTemp.infoByChapter[i].videoteca = this.itemStorage.videoteca
            this.seasonFilterByTemp.infoByChapter[i].storage = this.itemStorage.storage 
            this.seasonFilterByTemp.infoByChapter[i].typeStorage = this.itemStorage.typeStorage 
            this.seasonFilterByTemp.infoByChapter[i].codeDisk = this.itemStorage.codeDisk 
            this.seasonFilterByTemp.infoByChapter[i].copyBackUpStorage = this.itemStorage.copyBackUpStorage 
            }
           } else {
              this.seasonFilterByTemp.infoByChapter[i].dateCopy = ''
              this.seasonFilterByTemp.infoByChapter[i].stateStorage = ''
              this.seasonFilterByTemp.infoByChapter[i].videoteca = ''
              this.seasonFilterByTemp.infoByChapter[i].storage = ''
              this.seasonFilterByTemp.infoByChapter[i].typeStorage = [{typeStorage: '', codeDisk: ''}]
              this.seasonFilterByTemp.infoByChapter[i].codeDisk = ''
              this.seasonFilterByTemp.infoByChapter[i].copyBackUpStorage = ''
           }
        })
        console.log(this.seasonFilterByTemp.infoByChapter, 'this.seasonFilterByTemp.infoByChapter')
      },
      eventBtnCopy (item, chapter) {
        this.itemStorage = item
        this.indexStorage = chapter-1
        this.modalCopy = true
      },
      borrarInfo ( index, item ) {
        this.itemCap.dateCopy = ''
        this.itemCap.videoteca = ''
        this.itemCap.storage = ''
        this.itemCap.stateStorage = 'Pendiente'
        this.itemCap.typeStorage = [{typeStorage: '', codeDisk: ''}]
        this.itemCap.codeDisk = ''
        this.itemCap.copyBackUpStorage = ''
        this.clean = false
      },
      selectOption() {
        let existPend = this.seasonFilterByTemp.infoByChapter.filter(e => e.stateStorage == 'Pendiente' || e.stateStorage == undefined).length > 0
        this.checked = !existPend
      },
      isChooseCopyBackup(val) {
        if(!val || val === '') {
          return true
        } else {
          return false
        }
      }
    },
    computed: {
      totalNumbChapter () {
        let allCap = this.rangesCapsDefaulChanges.filter(
        m => m.radio == 'Recibido'
      ) 
       let capSelected = allCap

        if (this.textSearch) {
          capSelected = this.seasonFilterByTemp.infoByChapter.filter(
            m => modifyText(m.nameCap).indexOf(modifyText(this.textSearch)) > -1)
        }
      console.log(capSelected, 'capSelected')
        return capSelected       
      }, 
      capRegister () {
        let count = 0
        if(this.seasonFilterByTemp.infoByChapter) {
          this.seasonFilterByTemp.infoByChapter.map((el, i, arr) => {
            if(el.dateCopy !== '' && el.videoteca !== '' && el.storage !== '' && el.typeStorage !== '') {
              count += 1 
              this.seasonFilterByTemp.copiedChapters = count          
            }
          })
        }
        return count
      }
    },
  }
</script>


